%global pkg nesc
%global pkgname nesC

Name:           nesc
Version:        1.3.3
Release:        1%{?dist}
Summary:        Compiler used by TinyOS

Group:          Applications/Engineering
License:        GPLv2 and (GPLv2 or BSD)
URL:            http://nescc.sourceforge.net/
Source0:        http://downloads.sourceforge.net/project/nescc/nescc/v%{version}/%{name}-%{version}.tar.gz
Source1:        nesc-mode-init.el
Patch0:         nesc-load-el-without-extension.patch
Patch1:         nesc-1.3.2-vim-ftdetect.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  java-devel
BuildRequires:  jpackage-utils

%if 0%{?rhel} >= 6
BuildRequires:  puppet
%endif

Requires:       java 
Requires:       jpackage-utils
Requires:       perl
Requires:       vim-common

%description
The nesC language was designed to support the TinyOS project. 
nesC provides several advantages over C: a component model based 
on bi-directional interfaces, whole-program compilation for 
performance and a simple concurrency model for embedded systems.

# EL uses old cc-mode, so don't build it

%if 0%{?fedora}
%package -n emacs-%{pkg}
Summary:        Compiled elisp files to run %{pkgname} under GNU Emacs
Group:          Applications/Editors
BuildArch:      noarch
BuildRequires:  emacs
Requires:       emacs(bin) >= %{_emacs_version}

%description -n emacs-%{pkg}
This package contains the byte compiled elisp packages to run %{pkgname} with GNU
Emacs.


%package -n emacs-%{pkg}-el
Summary:        Elisp source files for %{pkgname} under GNU Emacs
Group:          Applications/Editors
BuildArch:      noarch
Requires:       emacs-%{pkg} = %{version}-%{release}

%description -n emacs-%{pkg}-el
This package contains the elisp source files for %{pkgname} under GNU Emacs. You
do not need to install this package to run %{pkgname}. Install the emacs-%{pkg}
package to use %{pkgname} with GNU Emacs.
%endif

%prep
%setup -q

%if 0%{?fedora}
%patch0 -p1 -b .emacs
%endif
%patch1 -p1 -b .fix

%build
%configure CFLAGS="%{optflags}"
%{__make} %{?_smp_mflags}

%if 0%{?fedora}
%{_emacs_bytecompile} tools/editor-modes/emacs/*.el
%endif

%install
%{__rm} -rf %{buildroot}
%{__make} install DESTDIR=%{buildroot}

%{__mkdir} -p %{buildroot}/%{_datadir}/vim/vimfiles/ftdetect
%{__mkdir} -p %{buildroot}/%{_datadir}/vim/vimfiles/syntax

%if 0%{?fedora}
%{__mkdir} -p %{buildroot}/%{_emacs_sitelispdir}/%{pkg}
%{__mkdir} -p %{buildroot}/%{_emacs_sitestartdir}

%{__install} -pm 644 tools/editor-modes/emacs/*.elc %{buildroot}/%{_emacs_sitelispdir}/%{pkg} 
%{__install} -pm 644 tools/editor-modes/emacs/*.el  %{buildroot}/%{_emacs_sitelispdir}/%{pkg}
%{__install} -pm 644 %{SOURCE1} %{buildroot}/%{_emacs_sitestartdir}

%endif


# properly install vim syntax file
%{__install} -pm 644 tools/editor-modes/vim/filetype.vim %{buildroot}/%{_datadir}/vim/vimfiles/ftdetect/nesc.vim
%{__install} -pm 644 tools/editor-modes/vim/nesc.vim %{buildroot}/%{_datadir}/vim/vimfiles/syntax/nesc.vim


%{__rm} -rf %{buildroot}/%{_datadir}/ncc/editor-modes/emacs
%{__rm} -rf %{buildroot}/%{_datadir}/ncc/editor-modes/gedit
%{__rm} -rf %{buildroot}/%{_datadir}/ncc/editor-modes/kde

%clean
%{__rm} -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc
%{_bindir}/%{name}*
%{_libdir}/ncc
%{_mandir}/man1/%{name}*.1.gz
%{_datadir}/ncc/
%{_datadir}/vim/vimfiles/ftdetect/%{pkg}.vim
%{_datadir}/vim/vimfiles/syntax/%{pkg}.vim

%if 0%{?fedora}
%files -n emacs-%{pkg}
%defattr(-,root,root,-)
%{_emacs_sitelispdir}/%{pkg}/*.elc
%{_emacs_sitestartdir}/*.el
%dir %{_emacs_sitelispdir}/%{pkg}

%files -n emacs-%{pkg}-el
%defattr(-,root,root,-)
%doc tools/editor-modes/emacs/readme.txt
%{_emacs_sitelispdir}/%{pkg}/*.el
%endif

%changelog
* Fri Dec 30 2011 Shakthi Kannan <shakthimaan [AT] fedoraproject DOT org> - 1.3.3-1
- Updated to 1.3.3.
- Provide vim files for EL6.

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Aug 18 2010 Shakthi Kannan <shakthimaan [AT] fedoraproject DOT org> - 1.3.2-3
- Added patch by Till Maas for vim support for nesC.

* Sat Aug 14 2010 Shakthi Kannan <shakthimaan [AT] fedoraproject DOT org> - 1.3.2-2
- Updated URL to use http://nescc.sourceforge.net

* Fri Aug 06 2010 Shakthi Kannan <shakthimaan [AT] fedoraproject DOT org> - 1.3.2-1
- Updated to upstream 1.3.2 release.
- Use GPLv2 and (GPLv2 or BSD) license.
- Use optflags with configure.
- Added BR perl.
- Added if construct for building emacs only for Fedora.
- Updated to use latest Emacs packaging guidelines.

* Fri Jul 02 2010 Shakthi Kannan <shakthimaan [AT] fedoraproject DOT org> - 1.3.1-2
- Added java-devel as BR.
- Created GNU Emacs sub-package.

* Tue May 12 2009 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> - 1.3.1-1
- Draft specification.
